﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SG_SDK_SHRC_SHOT_CS
{
    public partial class Form1 : Form
    {
        Class1 SHRC = new Class1();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            Module1.pCheckBoxEnable[0] = CheckBoxEnable_0;
            Module1.pCheckBoxEnable[1] = CheckBoxEnable_1;
            Module1.pCheckBoxEnable[2] = CheckBoxEnable_2;
            Module1.pLabel_Position[0] = Label_Position_0;
            Module1.pLabel_Position[1] = Label_Position_1;
            Module1.pLabel_Position[2] = Label_Position_2;
            Module1.pLabel_speed[0] = Label_Speed_0;
            Module1.pLabel_speed[1] = Label_Speed_1;
            Module1.pLabel_speed[2] = Label_Speed_2;
            
        }

        //Exit
        private void Button_Exit_Click(object sender, EventArgs e)
        {
            System.Environment.Exit(0);
        }

        //Comm
        private void Button_Comm_Click(object sender, EventArgs e)
        {
            int i, j;
            string[] data;
            string speed = "";

            try
            {
                if (SHRC.Connect() == false)
                    throw new Exception();
                else
                    this.Label_Comm.Text = "ON";

                if (Module1.AxisCount == 0 || Module1.AxisCount == 3 || Module1.AxisCount == 4 || Module1.AxisCount == 6)
                {
                    Module1.pCheckBoxEnable[0].Enabled = true;
                    GroupBox_0.Enabled = true;
                }
                if (Module1.AxisCount == 1 || Module1.AxisCount == 3 || Module1.AxisCount == 5 || Module1.AxisCount == 6)
                {
                    Module1.pCheckBoxEnable[1].Enabled = true;
                    GroupBox_1.Enabled = true;
                }
                if (Module1.AxisCount == 2 || Module1.AxisCount == 4 || Module1.AxisCount == 6)
                {
                    Module1.pCheckBoxEnable[2].Enabled = true;
                    GroupBox_2.Enabled = true;
                }

                // Speed
                if (SHRC.GetSpeed(ref speed) == false)
                    throw new Exception();
                data = speed.Split(',');
                j = 0;
                for (i = 0; i <= 2; i++)
                {
                    if (i == 0)
                    {
                        if (Module1.AxisCount == 1 || Module1.AxisCount == 2 || Module1.AxisCount == 5)
                        {
                            continue;
                        }
                    }
                    else if (i == 1)
                    {
                        if (Module1.AxisCount == 0 || Module1.AxisCount == 2 || Module1.AxisCount == 4)
                        {
                            continue;
                        }
                    }
                    Module1.pLabel_speed[i].Text = data[j];
                    j = j + 1;
                }

                SHRC.Wait_Ready();  // Show current position
            }
            catch
            {
                this.Label_Comm.Text = "Error";
            }
        }

        //Speed
        private void Button_SetSpeed_Click(object sender, EventArgs e)
        {
            string[] speed = new string[3];

            try
            {
                speed[0] = TextSpeed_S.Text;
                speed[1] = TextSpeed_F.Text;
                speed[2] = TextSpeed_R.Text;
                if (SHRC.SetSpeed(speed) == false)
                    throw new Exception();
            }
            catch 
            {
                MessageBox.Show("Error");
            }
        }

        //Home
        private void Button_Origin_Click(object sender, EventArgs e)
        {
            try
            {
                if (SHRC.ReturnOrigin() == false)
                    throw new Exception();
            }
            catch 
            {
                MessageBox.Show("Error");
            }
        }

        //Stop
        private void Button_Stop_Click(object sender, EventArgs e)
        {
            try
            {
                if (SHRC.StopStage() == false)
                    throw new Exception();
            }
            catch 
            {
                MessageBox.Show("Error");
            }
        }

        //Reset
        private void Button_ReSet_Click(object sender, EventArgs e)
        {
            try
            {
                if (SHRC.ResetPosition() == false)
                    throw new Exception();
            }
            catch
            {
                MessageBox.Show("Error");
            }
        }

        //Go
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            try
            {
                if (RadioButton_Rel.Checked == true || RadioButton_Abs.Checked == true)
                {
                    int[] value = new int[3];

                    value[0] = System.Convert.ToInt32(TextBox_Dist_0.Text);
                    value[1] = System.Convert.ToInt32(TextBox_Dist_1.Text);
                    value[2] = System.Convert.ToInt32(TextBox_Dist_2.Text);
                    if (RadioButton_Rel.Checked == true)
                    {
                        if (SHRC.Move(value) == false)
                            throw new Exception();
                    }
                    else if (SHRC.MoveAbs(value) == false)
                        throw new Exception();
                }
                else if (RadioButton_Jog_P.Checked == true)
                {
                    if (SHRC.JOG(true) == false)
                        throw new Exception();
                }
                else if (SHRC.JOG(false) == false)
                    throw new Exception();
            }
            catch 
            {
                MessageBox.Show("Error");
            }
        }
    }
}
