﻿Public Class Form1

    Dim SBIS As New Class1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        pCheckBoxEnable(0) = CheckBoxEnable_0
        pCheckBoxEnable(1) = CheckBoxEnable_1
        pCheckBoxEnable(2) = CheckBoxEnable_2
        pLabel_Position(0) = Label_Position_0
        pLabel_Position(1) = Label_Position_1
        pLabel_Position(2) = Label_Position_2

    End Sub

    'Exit
    Private Sub Button_Exit_Click(sender As Object, e As EventArgs) Handles Button_Exit.Click
        End
    End Sub

    'Comm
    Private Sub Button_Comm_Click(sender As Object, e As EventArgs) Handles Button_Comm.Click
        Dim buf As String = ""
        Dim i As Integer

        Try
            If SBIS.Connect = False Then
                Throw New Exception
            Else
                Me.Label_Comm.Text = "ON"
            End If

            If DeviceCount < 3 Then
                CheckBoxEnable_2.Checked = False
                GroupBox_2.Enabled = False
            End If
            If DeviceCount < 2 Then
                CheckBoxEnable_1.Checked = False
                GroupBox_1.Enabled = False
            End If

            'Speed
            For i = 0 To 2
                If i >= DeviceCount Then Exit For
                If SBIS.GetSpeed(i + 1, buf) = False Then Throw New Exception
                If i = 0 Then Label_Speed_0.Text = buf
                If i = 1 Then Label_Speed_1.Text = buf
                If i = 2 Then Label_Speed_2.Text = buf
            Next

            SBIS.Wait_Ready()  'Show current position
        Catch ex As Exception
            Me.Label_Comm.Text = "Error"
        End Try
    End Sub

    'Return Origin
    Private Sub Button_Origin_Click(sender As Object, e As EventArgs) Handles Button_Origin.Click
        Try
            If SBIS.ReturnOrigin = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Speed
    Private Sub Button_SetSpeed_Click(sender As Object, e As EventArgs) Handles Button_SetSpeed.Click
        Dim speed(2) As String

        Try
            speed(0) = TextSpeed_S.Text
            speed(1) = TextSpeed_F.Text
            speed(2) = TextSpeed_R.Text
            If SBIS.SetSpeed(speed) = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Stop
    Private Sub Button_Stop_Click(sender As Object, e As EventArgs) Handles Button_Stop.Click
        Try
            If SBIS.StopStage = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Reset
    Private Sub Button_ReSet_Click(sender As Object, e As EventArgs) Handles Button_ReSet.Click
        Try
            If SBIS.ResetPosition = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Go
    Private Sub ButtonMove_Click(sender As Object, e As EventArgs) Handles ButtonMove.Click

        Try
            If RadioButton_Rel.Checked = True OrElse RadioButton_Abs.Checked = True Then
                Dim value(2) As Integer

                value(0) = CInt(TextBox_Dist_0.Text)
                value(1) = CInt(TextBox_Dist_1.Text)
                value(2) = CInt(TextBox_Dist_2.Text)
                If RadioButton_Rel.Checked = True Then
                    If SBIS.Move(value) = False Then Throw New Exception
                Else
                    If SBIS.MoveAbs(value) = False Then Throw New Exception
                End If
            Else
                If RadioButton_Jog_P.Checked = True Then
                    If SBIS.JOG(True) = False Then Throw New Exception
                Else
                    If SBIS.JOG(False) = False Then Throw New Exception
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

End Class

