﻿Public Class Form1

    Dim SHRC As New Class1


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        pCheckBoxEnable(0) = CheckBoxEnable_0
        pCheckBoxEnable(1) = CheckBoxEnable_1
        pCheckBoxEnable(2) = CheckBoxEnable_2
        pLabel_Position(0) = Label_Position_0
        pLabel_Position(1) = Label_Position_1
        pLabel_Position(2) = Label_Position_2
        pLabel_speed(0) = Label_Speed_0
        pLabel_speed(1) = Label_Speed_1
        pLabel_speed(2) = Label_Speed_2

    End Sub

    'Exit
    Private Sub Button_Exit_Click(sender As Object, e As EventArgs) Handles Button_Exit.Click
        End
    End Sub

    'Comm
    Private Sub Button_Comm_Click(sender As Object, e As EventArgs) Handles Button_Comm.Click
        Dim i, j As Integer
        Dim data() As String
        Dim speed As String = ""

        Try
            If SHRC.Connect = False Then
                Throw New Exception
            Else
                Me.Label_Comm.Text = "ON"
            End If

            If AxisCount = 0 OrElse AxisCount = 3 OrElse AxisCount = 4 OrElse AxisCount = 6 Then
                pCheckBoxEnable(0).Enabled = True
                GroupBox_0.Enabled = True
            End If
            If AxisCount = 1 OrElse AxisCount = 3 OrElse AxisCount = 5 OrElse AxisCount = 6 Then
                pCheckBoxEnable(1).Enabled = True
                GroupBox_1.Enabled = True
            End If
            If AxisCount = 2 OrElse AxisCount = 4 OrElse AxisCount = 6 OrElse AxisCount = 6 Then
                pCheckBoxEnable(2).Enabled = True
                GroupBox_2.Enabled = True
            End If

            'Speed
            If SHRC.GetSpeed(speed) = False Then Throw New Exception
            data = speed.Split(",")
            j = 0
            For i = 0 To 2
                If i = 0 Then
                    If AxisCount = 1 OrElse AxisCount = 2 OrElse AxisCount = 5 Then Continue For
                ElseIf i = 1 Then
                    If AxisCount = 0 OrElse AxisCount = 2 OrElse AxisCount = 4 Then Continue For
                End If
                pLabel_speed(i).Text = data(j)
                j = j + 1
            Next

            SHRC.Wait_Ready()  'Show current position
        Catch ex As Exception
            Me.Label_Comm.Text = "Error"
        End Try
    End Sub

    'Speed
    Private Sub Button_SetSpeed_Click(sender As Object, e As EventArgs) Handles Button_SetSpeed.Click
        Dim speed(2) As String

        Try
            speed(0) = TextSpeed_S.Text
            speed(1) = TextSpeed_F.Text
            speed(2) = TextSpeed_R.Text
            If SHRC.SetSpeed(speed) = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Home
    Private Sub Button_Origin_Click(sender As Object, e As EventArgs) Handles Button_Origin.Click
        Try
            If SHRC.ReturnOrigin = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Stop
    Private Sub Button_Stop_Click(sender As Object, e As EventArgs) Handles Button_Stop.Click
        Try
            If SHRC.StopStage = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Reset
    Private Sub Button_ReSet_Click(sender As Object, e As EventArgs) Handles Button_ReSet.Click
        Try
            If SHRC.ResetPosition = False Then Throw New Exception
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub

    'Go
    Private Sub ButtonMove_Click(sender As Object, e As EventArgs) Handles ButtonMove.Click

        Try
            If RadioButton_Rel.Checked = True OrElse RadioButton_Abs.Checked = True Then
                Dim value(2) As Integer

                value(0) = CInt(TextBox_Dist_0.Text)
                value(1) = CInt(TextBox_Dist_1.Text)
                value(2) = CInt(TextBox_Dist_2.Text)
                If RadioButton_Rel.Checked = True Then
                    If SHRC.Move(value) = False Then Throw New Exception
                Else
                    If SHRC.MoveAbs(value) = False Then Throw New Exception
                End If
            Else
                If RadioButton_Jog_P.Checked = True Then
                    If SHRC.JOG(True) = False Then Throw New Exception
                Else
                    If SHRC.JOG(False) = False Then Throw New Exception
                End If
            End If
        Catch ex As Exception
            MessageBox.Show("Error")
        End Try
    End Sub
End Class
